// Copyright 2024 Patial Tech. All rights reserved.
// Use of this source code is governed by a BSD-style
// license that can be found in the LICENSE file.

package message

import _ "embed"

//go:embed welcome.html
var welcomeHtml string

type Welcome struct {
	Name      string
	VerifyURL string
}

func (e *Welcome) Subject() string {
	return "Welcome, " + e.Name
}

func (e *Welcome) HtmlBody() (string, error) {
	return render(layout, welcomeHtml, e)
}
