// Copyright 2024 Patial Tech. All rights reserved.
// Use of this source code is governed by a BSD-style
// license that can be found in the LICENSE file.

package crypto

import "testing"

func TestPasswordHash(t *testing.T) {
	pwd := "MY Bingo pwd"
	hash, salt, err := PasswordHash(pwd)
	if err != nil {
		t.Error(err)
		return
	}

	if hash == "" || salt == "" {
		t.Error("either hash or password is empty")
		return
	}

	if !ComparePasswordHash(pwd, string(hash), string(salt)) {
		t.Error("supposed to match")
	}

}
